#!perl


require 'getopts.pl';
require 'rkheader.pl';
require 'romakana.pl';
use Jcode;
my $scriptcode = 'euc';
my $consolecode = 'sjis';

sub usage {
	print STDERR "krtest - test Roma-Kana\n";
	print STDERR " % krtest word\n";
	print STDERR " % krtest -f wordsfile\n";
	exit;
}


my $word;

&usage unless &Getopts('f');
&usage unless $word = shift;

$options = join(' ', @ARGV);

&main;


sub main {
	my $result;
	if($opt_f) {
		open(table, "$word") || die "Can't open words file.";
		while(<table>){
			chop;
			next if /^#/;
			
			$result = &camel_convert($_);
			my $test = &camel_convert($result);
			if($_ eq $test) {
				print "OK : $_ -> $result\n";
			} else {
				print "NG : $_ -> $result -> $test\n";
			}
		}
		close table;
	} else {
		$result = &camel_convert($word);
		print "$word -> $result\n";
	}
}

sub camel_convert {
	my ($word) = @_; 
	my $source = &trim_spaces($word);
	my $result;
	
	&code_convert(\$source, $scriptcode, $consolecode);
	if(&Jcode::getcode($source) eq 'ascii') {
		$source =~ s/[A-Z]/:$&/g;
		$source =~ s/^://g;
		print "($source)\n" unless($opt_f);
		my @p = split(/:/, $source);
		my @r;
		foreach ( @p ) {
			my $w = &roma2kana($_);
			push @r, $w;
		}
		$result = join '', @r;
		&code_convert(\$result, $consolecode, $scriptcode);
	} else {
		my @p = split('', $source);
		foreach ( @p ) {
			my $w = &kana2roma($_);
			print "<$w>" unless($opt_f);
			split( /,/, $w );
			$w = @_[0];
			$result .= "\L\u$w";
		}
	}
	return $result;
}

sub code_convert {
    my ($contentref, $outcode, $incode) = @_;
	$incode = $scriptcode unless(defined $incode);
	&Jcode::convert($contentref, $outcode, $incode) if($outcode ne $incode);
    return $contentref;
}

sub trim_spaces {
	my ( $src ) = @_;
	
	$src =~ s/^\s*(.*?)\s*$/$1/;		# trim space
	return $src;
}


